/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "XS.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#define CHECK_INDEX(idx, min, max, ret) if(idx < min || idx > max) {	\
		croak("Index not in range [" IVdf "," IVdf "]", (IV)(min), (IV)(max)); \
		return ret;														\
	}

typedef struct {
	IV n;
	IV* t;
} bit;

bit* bit_create(IV len) {
	if(len < 1){
		croak("Length less than 1");
		return 0;
	}
	len++;
	bit *ret;
	Newx(ret, 1, bit);
	ret->n = len;
	Newxz(ret->t, len, IV);
	return ret;
}

void bit_free(bit *b) {
	Safefree(b->t);
	Safefree(b);
}

IV bit_query(bit *b, IV idx) {
	CHECK_INDEX(idx, 0, b->n - 1, 0);
	IV ret = 0;
	while(idx)
		ret += b->t[idx], idx -= idx & -idx;
	return ret;
}

void bit_update(bit *b, IV idx, IV value) {
	CHECK_INDEX(idx, 0, b->n - 1, );
	while(idx < b->n)
		b->t[idx] += value, idx += idx & -idx;
}

void bit_clear(bit *b) {
	Zero(b->t, b->n, IV);
}

typedef struct {
	IV n, m;
	IV* t;
} bit2d;

bit2d* bit2d_create(IV n, IV m) {
	if(n < 1 || m < 1){
		croak("A dimension is less than 1");
		return 0;
	}
	n++, m++;
	bit2d *ret;
	Newx(ret, 1, bit2d);
	ret->n = n;
	ret->m = m;
	Newxz(ret->t, n * m, IV);
	return ret;
}

void bit2d_free(bit2d *b) {
	Safefree(b->t);
	Safefree(b);
}

IV bit2d_query(bit2d *b, IV i1, IV i2) {
	CHECK_INDEX(i1, 1, b->n - 1, 0);
	CHECK_INDEX(i2, 1, b->m - 1, 0);
	if(i1 > b->n || i1 < 1) {
		croak("Index 1 not in range [1," IVdf "]", b->n);
		return 0;
	}
	if(i2 > b->m || i2 < 1) {
		croak("Index 2 not in range [1," IVdf "]", b->m);
		return 0;
	}
	IV ret = 0, i2c = i2;
	while(i1) {
		i2 = i2c;
		while(i2)
			ret += b->t[i1 * b->m + i2], i2 -= i2 & -i2;
		i1 -= i1 & -i1;
	}
	return ret;
}

void bit2d_update(bit2d *b, IV i1, IV i2, IV value) {
	CHECK_INDEX(i1, 1, b->n - 1, );
	CHECK_INDEX(i2, 1, b->m - 1, );
	IV i2c = i2;
	while(i1 < b->n) {
		i2 = i2c;
		while(i2 < b->m)
			b->t[i1 * b->m + i2] += value, i2 += i2 & -i2;
		i1 += i1 & -i1;
	}
}

void bit2d_clear(bit2d *b) {
	Zero(b->t, b->n * b->m, IV);
}

typedef bit *Algorithm__BIT__XS;
typedef bit2d *Algorithm__BIT2D__XS;

#line 128 "XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 272 "XS.c"

XS_EUPXS(XS_Algorithm__BIT__XS_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__BIT__XS_create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "len");
    {
	Algorithm__BIT__XS	RETVAL;
	IV	len = (IV)SvIV(ST(0))
;

	RETVAL = bit_create(len);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Algorithm::BIT::XS", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__BIT__XS_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__BIT__XS_free)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "b");
    {
	Algorithm__BIT__XS	b;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Algorithm::BIT::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    b = INT2PTR(Algorithm__BIT__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"b", "Algorithm::BIT::XS")
;

	bit_free(b);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__BIT__XS_query); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__BIT__XS_query)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "b, idx");
    {
	IV	RETVAL;
	dXSTARG;
	Algorithm__BIT__XS	b;
	IV	idx = (IV)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Algorithm::BIT::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    b = INT2PTR(Algorithm__BIT__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Algorithm::BIT::XS::query",
			"b", "Algorithm::BIT::XS")
;

	RETVAL = bit_query(b, idx);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__BIT__XS_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__BIT__XS_update)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "b, idx, value");
    {
	Algorithm__BIT__XS	b;
	IV	idx = (IV)SvIV(ST(1))
;
	IV	value = (IV)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Algorithm::BIT::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    b = INT2PTR(Algorithm__BIT__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Algorithm::BIT::XS::update",
			"b", "Algorithm::BIT::XS")
;

	bit_update(b, idx, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__BIT__XS_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__BIT__XS_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "b");
    {
	Algorithm__BIT__XS	b;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Algorithm::BIT::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    b = INT2PTR(Algorithm__BIT__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Algorithm::BIT::XS::clear",
			"b", "Algorithm::BIT::XS")
;

	bit_clear(b);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__BIT2D__XS_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__BIT2D__XS_create)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "n, m");
    {
	Algorithm__BIT2D__XS	RETVAL;
	IV	n = (IV)SvIV(ST(0))
;
	IV	m = (IV)SvIV(ST(1))
;

	RETVAL = bit2d_create(n, m);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Algorithm::BIT2D::XS", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__BIT2D__XS_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__BIT2D__XS_free)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "b");
    {
	Algorithm__BIT2D__XS	b;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Algorithm::BIT2D::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    b = INT2PTR(Algorithm__BIT2D__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"b", "Algorithm::BIT2D::XS")
;

	bit2d_free(b);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__BIT2D__XS_query); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__BIT2D__XS_query)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "b, i1, i2");
    {
	IV	RETVAL;
	dXSTARG;
	Algorithm__BIT2D__XS	b;
	IV	i1 = (IV)SvIV(ST(1))
;
	IV	i2 = (IV)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Algorithm::BIT2D::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    b = INT2PTR(Algorithm__BIT2D__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Algorithm::BIT2D::XS::query",
			"b", "Algorithm::BIT2D::XS")
;

	RETVAL = bit2d_query(b, i1, i2);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Algorithm__BIT2D__XS_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__BIT2D__XS_update)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "b, i1, i2, value");
    {
	Algorithm__BIT2D__XS	b;
	IV	i1 = (IV)SvIV(ST(1))
;
	IV	i2 = (IV)SvIV(ST(2))
;
	IV	value = (IV)SvIV(ST(3))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Algorithm::BIT2D::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    b = INT2PTR(Algorithm__BIT2D__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Algorithm::BIT2D::XS::update",
			"b", "Algorithm::BIT2D::XS")
;

	bit2d_update(b, i1, i2, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Algorithm__BIT2D__XS_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Algorithm__BIT2D__XS_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "b");
    {
	Algorithm__BIT2D__XS	b;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Algorithm::BIT2D::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    b = INT2PTR(Algorithm__BIT2D__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Algorithm::BIT2D::XS::clear",
			"b", "Algorithm::BIT2D::XS")
;

	bit2d_clear(b);
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Algorithm__BIT__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Algorithm__BIT__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Algorithm::BIT::XS::create", XS_Algorithm__BIT__XS_create, file, "$");
        cv = newXSproto_portable("Algorithm::BIT::XS::DESTROY", XS_Algorithm__BIT__XS_free, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Algorithm::BIT::XS::free", XS_Algorithm__BIT__XS_free, file, "$");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Algorithm::BIT::XS::query", XS_Algorithm__BIT__XS_query, file, "$$");
        (void)newXSproto_portable("Algorithm::BIT::XS::update", XS_Algorithm__BIT__XS_update, file, "$$$");
        (void)newXSproto_portable("Algorithm::BIT::XS::clear", XS_Algorithm__BIT__XS_clear, file, "$");
        (void)newXSproto_portable("Algorithm::BIT2D::XS::create", XS_Algorithm__BIT2D__XS_create, file, "$$");
        cv = newXSproto_portable("Algorithm::BIT2D::XS::DESTROY", XS_Algorithm__BIT2D__XS_free, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Algorithm::BIT2D::XS::free", XS_Algorithm__BIT2D__XS_free, file, "$");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Algorithm::BIT2D::XS::query", XS_Algorithm__BIT2D__XS_query, file, "$$$");
        (void)newXSproto_portable("Algorithm::BIT2D::XS::update", XS_Algorithm__BIT2D__XS_update, file, "$$$$");
        (void)newXSproto_portable("Algorithm::BIT2D::XS::clear", XS_Algorithm__BIT2D__XS_clear, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

